=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DEVHTP_BUILD_SHARED:STRING=ON -DBUILD_SHARED_LIBS:STRING=ON 

override_dh_auto_build:
	dh_auto_build
	mkdir -p html
	doxygen

override_dh_auto_install:
	dh_auto_install
	# CMake does not support to specify the directory where to put multiarch stuff
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	mv debian/tmp/usr/lib/lib* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/pkgconfig debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_strip:
	dh_strip --dbgsym-migration='libevhtp0-dbg (<< 1.2.11-3~)'

override_dh_auto_clean:
	dh_auto_clean
	rm -rf html
