=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libevhtp-$1.tar.gz/ \
  https://github.com/Yellow-Camper/libevhtp/tags .*/v?(\d[\d.]*)\.tar\.gz
